-- Author      : Nogarder
-- Create Date : 2013/11/3 10:08:53
--NPA.DataCollector.RegisterModule( datatype, initfunc, uninitfunc )
NPA.FriendsList={
	FriendList={},
	GuildList={},
	PartyList={},
	RaidList={},
}
NPA.DataCollector.RegisterModule("Friends",
	function()
		--friendlist
		local FriendList={}
		local GuildList={}
		local PartyList={}
		local RaidList={}
		NPA.FriendsList.FriendList=FriendList
		NPA.FriendsList.GuildList=GuildList
		NPA.FriendsList.PartyList=PartyList
		NPA.FriendsList.RaidList=RaidList
		--
		NPA.EventHandler.RegisterEvent(0,"FRIENDLIST_UPDATE","DataCollector_Friends",function()
			FriendList={}
			--numberOfFriends, onlineFriends = GetNumFriends()
			local num = GetNumFriends() or 0
			local myname=UnitName("player")
			for i=1,num do
				--name, level, class, area, connected, status, note = GetFriendInfo(friendIndex);
				local name,_,_,_,connected=GetFriendInfo(i)
				if(connected and name and name~=myname)then
					FriendList[name]=true
				end
			end
		end)
		--
		NPA.EventHandler.RegisterEvent(0,"GUILD_ROSTER_UPDATE","DataCollector_Friends",function()
			GuildList={}
			--numTotalMembers, numOnlineMembers = GetNumGuildMembers();
			local num = GetNumGuildMembers() or 0
			local myname=UnitName("player")
			for i=1,num do
				--name, rank, rankIndex, level, class, zone, note, 
				--officernote, online, status, classFileName, 
				--achievementPoints, achievementRank, isMobile = GetGuildRosterInfo(index);
				local name,_,_,_,_,_,_,_,online = GetGuildRosterInfo(i)
				if(online and name~=myname)then
					GuildList[name]=true
				end
			end
		end)

		local function PartyRaidChanged()
			PartyList={}
			RaidList={}
			local playername=UnitName("player")
			local raidn=GetNumRaidMembers()
			if(raidn)then
				for i=1,raidn do
					local name=UnitName("raid"..i)
					if(name~=playername)then
						RaidList[name]=true
					end
				end
			end
			local partyn=GetNumPartyMembers()
			if(partyn)then
				for i=1,partyn do
					local name=UnitName("party"..i)
					PartyList[name]=true
				end
			end
		end
		
		NPA.EventHandler.RegisterEvent(0,"PARTY_MEMBERS_CHANGED","DataCollector_Friends",PartyRaidChanged)
		NPA.EventHandler.RegisterEvent(0,"RAID_ROSTER_UPDATE","DataCollector_Friends",PartyRaidChanged)
	end,
	--------
	function()
		--clear up table
		NPA.FriendsList.FriendList={}
		NPA.FriendsList.GuildList={}
		NPA.FriendsList.PartyList={}
		NPA.FriendsList.RaidList={}
		-------unregister all events
		NPA.EventHandler.RegisterEvent(0,"FRIENDLIST_UPDATE","DataCollector_Friends",nil)
		NPA.EventHandler.RegisterEvent(0,"GUILD_ROSTER_UPDATE","DataCollector_Friends",nil)
		NPA.EventHandler.RegisterEvent(0,"PARTY_MEMBERS_CHANGED","DataCollector_Friends",nil)
		NPA.EventHandler.RegisterEvent(0,"RAID_ROSTER_UPDATE","DataCollector_Friends",nil)
	end,
	--data transfer function,transfer frame-based unitdata to guid-based unitdata
	function()
	end,
	--data clear function
	function()
	end
	)

